	INCLUDE EFR32MG12.inc			; CPU register definitions	
	INCLUDE	defines.inc

	AREA    |.text|, CODE, READONLY	; another section in the CODE area	
;-------------------------------------------------------------------------------
GPIO_setup	PROC				; I/O Ports configuration
	EXPORT	GPIO_setup
	OORW	1<<3, CMU_HFBUSCLKEN0, CMU	; enable clock to GPIO
	OORW	(0x11<<24), GPIO_PD_MODEH, GPIO	; configure PD14,15 for digital input
	OORW	0x44, GPIO_PD_MODEH		; congigure PD8,9 for RG LED
	bx	LR
	ENDP	

;------------------------------------------------
LETIMER_setup	PROC
	EXPORT	LETIMER_setup
	PUTW	1, CMU_LFACLKEN0, CMU		; enable LFA clock for LETIMER
	PUTW	2, CMU_LFAPRESC0		; use 1:4 prescaler
	PUTW	1<<9, LETIMERn_CTRL, LETIMER0	; set count to TOP mode
	PUTW	4, LETIMERn_IEN			; enable UF interrupt			
	OORW	1<<27, 0, NVIC_ISER0		; enable LETIMER interrupt in NVIC
	bx	LR
	ENDP
						
;-----------------------------------------------
TIMER0_setup	PROC
	EXPORT	TIMER0_setup
	OORW	1, CMU_HFPERCLKEN0, CMU		; enable clock to TIMER0
	PUTW	10<<24, TIMERn_CTRL, TIMER0	; use 1:1024 pre-scaler
	PUTW	0, TIMERn_CNT			; zero timer counter		
	PUTW	(3<<26)+(1<<24)+1, TIMERn_CC1_CTRL ; set CC1 capture mode			
	PUTW	21<<8, TIMERn_ROUTELOC0		; set CC1 capture from pin PD14
	PUTW	2, TIMERn_ROUTEPEN		; enable CC1 capture from this pin
	PUTW	(1<<5)+1, TIMERn_IEN		; enable timer interrupts
	OORW	1<<11, 0, NVIC_ISER0		; enable TIMER0 interrupt in NVIC
	bx	LR
	ENDP
		
;--------------------------------------------------------
TRNG_setup	PROC
	EXPORT	TRNG_setup
	OORW	(1<<17), CMU_HFPERCLKEN0, CMU	; enable clock to TRNG
	PUTW	1, TRNGn_CONTROL, TRNG0		; enable TRNG	
ts1	
	GETW	TRNGn_STATUS, TRNG0		; R1 = status
	lsrs	R1, #8
	bcc	ts1				; wait for filling the FIFO	
	bx	LR	
	ENDP
		
	ALIGN
	END
	